using YBEE.EQM.Core;

namespace YBEE.EQM.Application;

/// <summary>
/// 监测发布内容管理服务
/// </summary>
public interface IExamDataPublishService
{
    #region 创建更新
    /// <summary>
    /// 添加发布内容
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Add(AddExamDataPublishInput input);
    /// <summary>
    /// 更新发布内容
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Update(UpdateExamDataPublishInput input);
    /// <summary>
    /// 删除发布内容
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Del(BaseId input);
    #endregion

    #region 状态处理
    /// <summary>
    /// 发布
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Publish(BaseId input);
    /// <summary>
    /// 取消
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Unpublish(BaseId input);
    #endregion

    #region 查询
    /// <summary>
    /// 根据ID获取监测数据发布内容
    /// </summary>
    /// <param name="id"></param>
    /// <returns></returns>
    Task<ExamDataPublishOutput> GetById(int id);
    /// <summary>
    /// 根据监测计划ID获取数据发布内容列表
    /// </summary>
    /// <param name="examPlanId"></param>
    /// <returns></returns>
    Task<List<ExamDataPublishOutput>> GetListByExamPlanId(int examPlanId);
    #endregion
}
